﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;

namespace CopyCenter
{
    /// <summary>
    /// Логика взаимодействия для OrdersWindow.xaml
    /// </summary>
    public partial class OrdersWindow : Window
    {
        gr672_liiEntities db;

        public OrdersWindow()
        {
            InitializeComponent();
            db = new gr672_liiEntities();
            comboBox1.ItemsSource = db.Services.ToList();
            comboBox1.DisplayMemberPath = "NameService";
            comboBox1.SelectedValuePath = "idService";

            comboBox2.ItemsSource = db.Clients.ToList();
            comboBox2.DisplayMemberPath = "NameClient";
            comboBox2.SelectedValuePath = "idClient";

            comboBox4.ItemsSource = db.Users.ToList();
            comboBox4.DisplayMemberPath = "Login";
            comboBox4.SelectedValuePath = "idUser";

            comboBox3.ItemsSource = db.Payments.ToList();
            comboBox3.DisplayMemberPath = "NumberPayment";
            comboBox3.SelectedValuePath = "idPayment";
            ShowOrder();

        }

        private void Exit_Click(object sender, RoutedEventArgs e)
        {
            MenuWindow mw = new MenuWindow();
            mw.Show();
            this.Close();
        }

        private void Add(object sender, RoutedEventArgs e)
        {
            if (Number.Text == "" || View.Text == "" || Date.Text == "" || Price.Text == "" || comboBox2.SelectedValue.ToString() == "" || comboBox1.SelectedValue.ToString() == "" || comboBox4.SelectedValue.ToString() == "" || comboBox3.SelectedValue.ToString() == "")
            {
                MessageBox.Show("Введено неверное значение");
                return;
            }
            Order order = new Order();
            order.NumberOrder = Convert.ToInt32(Number.Text);
            order.ViewOrder = View.Text;
            order.OrderDate = Convert.ToDateTime(Date.Text);
            order.CostOrder = Convert.ToInt32(Price.Text);
            order.idClient = Convert.ToInt32(comboBox2.SelectedValue.ToString());
            order.idService = Convert.ToInt32(comboBox1.SelectedValue.ToString());
            order.idUser = Convert.ToInt32(comboBox4.SelectedValue.ToString());
            order.idPayment = Convert.ToInt32(comboBox3.SelectedValue.ToString());
            db.Orders.Add(order);
            db.SaveChanges();
            MessageBox.Show("Успешно зарегистрирован заказ");
            OrdersList.ItemsSource = db.Orders.ToList();

        }

        private void Delete(object sender, RoutedEventArgs e)
        {
            var result = MessageBox.Show("Вы точно хотите удалить заказ?", "Подтверждение", MessageBoxButton.YesNo, MessageBoxImage.Question);
            if (result == MessageBoxResult.Yes)
            {
                Order order = (Order)OrdersList.SelectedItem;
                db.Orders.Remove(order);
                db.SaveChanges();
                MessageBox.Show("Успешно удалён заказ");
                OrdersList.ItemsSource = db.Orders.ToList();
            }
        }

        private void Update(object sender, RoutedEventArgs e)
        {
            if (Number.Text == "" || View.Text == "" || Date.Text == "" || Price.Text == "" || comboBox2.SelectedValue.ToString() == "" || comboBox1.SelectedValue.ToString() == "" || comboBox4.SelectedValue.ToString() == "" || comboBox3.SelectedValue.ToString() == "")
            {
                MessageBox.Show("Введено неверное значение");
                return;
            }
            int num = 0;
            int.TryParse(ID.Text, out num);
            var uRow = db.Orders.Where(w => w.idOrder == num).FirstOrDefault();
            uRow.NumberOrder = Convert.ToInt32(Number.Text);
            uRow.ViewOrder = View.Text;
            uRow.OrderDate = Convert.ToDateTime(Date.Text);
            uRow.CostOrder = Convert.ToInt32(Price.Text);
            uRow.idClient = Convert.ToInt32(comboBox2.SelectedValue.ToString());
            uRow.idService = Convert.ToInt32(comboBox1.SelectedValue.ToString());
            uRow.idUser = Convert.ToInt32(comboBox4.SelectedValue.ToString());
            uRow.idPayment = Convert.ToInt32(comboBox3.SelectedValue.ToString());
            db.SaveChanges();
            MessageBox.Show("Успешно отредактировано поле");
            OrdersList.ItemsSource = db.Orders.ToList();
        }

        private void Window_Loaded(object sender, RoutedEventArgs e)
        {
            db = new gr672_liiEntities();
            OrdersList.ItemsSource = db.Orders.ToList();
        }

        public void ShowOrder()
        {
            var SelectOrders = db.Orders.Where(item => item.NumberOrder.ToString().Contains(Search.Text));
            OrdersList.ItemsSource = SelectOrders.ToList();

        }

        private void Search_TextChanged(object sender, TextChangedEventArgs e)
        {
            ShowOrder();
        }

    }
}
