﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;

namespace CopyCenter
{
    /// <summary>
    /// Логика взаимодействия для ServicesWindow.xaml
    /// </summary>
    public partial class ServicesWindow : Window
    {
        gr672_liiEntities db;
        public ServicesWindow()
        {
            InitializeComponent();
            db = new gr672_liiEntities();
            comboBox1.ItemsSource = db.CategoryServices.ToList();
            comboBox1.DisplayMemberPath = "NameCategory";
            comboBox1.SelectedValuePath = "idCategory";
        }

        private void Exit_Click(object sender, RoutedEventArgs e)
        {
            MenuWindow mw = new MenuWindow();
            mw.Show();
            this.Close();
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            if (Name.Text == "" || Price.Text == "" || Description.Text == "" || comboBox1.SelectedValue.ToString() == "")
            {
                MessageBox.Show("Введено неверное значение");
                return;
            }
            
            Service service = new Service();
            int price = 0;
            int.TryParse(Price.Text,out price);
            service.NameService = Name.Text;
            service.PriceService = price;
            service.DescriptionService = Description.Text;
            service.idCategory = Convert.ToInt32(comboBox1.SelectedValue.ToString());
            db.Services.Add(service);
            db.SaveChanges();
            MessageBox.Show("Успешно добавлена услуга");
            ServicesList.ItemsSource = db.Services.ToList();
        }

        private void Update(object sender, RoutedEventArgs e)
        {
            if (Name.Text == "" || Price.Text == "" || Description.Text == "" || comboBox1.SelectedValue.ToString() == "")
            {
                MessageBox.Show("Введено неверное значение");
                return;
            }
            int price;
            int.TryParse(Price.Text, out price);
            int num;
            int.TryParse(ID.Text, out num);
            var uRow = db.Services.Where(w => w.idService == num).FirstOrDefault();
            uRow.NameService = Name.Text;
            uRow.PriceService = price;
            uRow.DescriptionService = Description.Text;
            uRow.idCategory = Convert.ToInt32(comboBox1.SelectedValue.ToString());
            db.SaveChanges();
            MessageBox.Show("Успешно удалена услуга");
            ServicesList.ItemsSource = db.Services.ToList();
        }
        private void Window_Loaded(object sender, RoutedEventArgs e)
        {
            db = new gr672_liiEntities();
            ServicesList.ItemsSource = db.Services.ToList();
        }

        private void Delete(object sender, RoutedEventArgs e)
        {    
            var result = MessageBox.Show("Вы точно хотите удалить услугу?", "Подтверждение", MessageBoxButton.YesNo, MessageBoxImage.Question);
            if (result==MessageBoxResult.Yes)
            {
                Service service = (Service)ServicesList.SelectedItem;
                db.Services.Remove(service);
                db.SaveChanges();
                MessageBox.Show("Успешно отредактировано поле");
                ServicesList.ItemsSource = db.Services.ToList();
            }          
           
        }
    }
}

